//       MT-12232A, MT-12232C, MT-12232D

void main(void) {
byte	p;//   
byte	c;//    

	LCDinit();
	for(p=0; p<4; p++) {//   4-  
		WriteCodeL(p|0xB8);//      
		WriteCodeL(0x13);//            
		for(c=0; c<61; c++) {//      
			WriteDataL(Logo122[p][c]);//    
		}
		WriteCodeR(p|0xB8);//      
		WriteCodeR(0x00);//            
		for(c=61; c<122; c++) {//      
			WriteDataR(Logo122[p][c]);//    
		}
	}
}

//   
void LCDinit(void) {
	LCD.E=1;//   
	LCD.RES=0;//  RES=0 
	Delay(>10us);//    10 
	LCD.RES=1;//  RES
	Delay(>1ms);//    1 
	WriteCodeL(0xE2);//Reset
	WriteCodeR(0xE2);//Reset
	WriteCodeL(0xEE);//ReadModifyWrite off
	WriteCodeR(0xEE);//ReadModifyWrite off
	WriteCodeL(0xA4);//  
	WriteCodeR(0xA4);//  
	WriteCodeL(0xA9);// 1/32
	WriteCodeR(0xA9);// 1/32
	WriteCodeL(0xC0);//   0
	WriteCodeR(0xC0);//   0
	WriteCodeL(0xA1);//Invert scan RAM
	WriteCodeR(0xA0);//NonInvert scan RAM
	WriteCodeL(0xAF);//Display on
	WriteCodeR(0xAF);//Display on
}

void Pset(byte x, byte y, bit c) {//     ( 0,0     )
byte c8;//     
byte m8;//    
	if ((x>121)||(y>31)) return;//   
	if (x<61) {//    
		WriteCodeL(0xB8|(y>>3));//   
		WriteCodeL(0x13+x);//   
		c8=ReadDataL();// 
		c8=ReadDataL();//    
		m8=1<<(y&0x07);//     
		if (c==1)	// ?
			c8|=m8//    
		else		//  ?
			c8&=~m8;//    
		WriteCodeL(0x13+x);//    
		WriteDataL(c8);//     
	} else {//    
		WriteCodeR(0xB8|(y>>3));//   
		WriteCodeR(x-61);//   
		c8=ReadDataR();// 
		c8=ReadDataR();//    
		m8=1<<(y&0x07);//     
		if (c==1)	// ?
			c8|=m8//    
		else		//  ?
			c8&=~m8;//    
		WriteCodeR(x-61);//    
		WriteDataR(c8);//     
	}
}

void WriteCodeL(byte b) { WriteByte(b,0,1); }//    
void WriteCodeR(byte b) { WriteByte(b,0,0); }//    

void WriteDataL(byte b) { WriteByte(b,1,1); }//    
void WriteDataR(byte b) { WriteByte(b,1,0); }//    

byte ReadDataL(void) { return ReadByte(1,1); }//      
byte ReadDataR(void) { return ReadByte(1,0); }//      

//    
void WriteByte(byte b, bit cd, bit lr) {
//       
	LCD.RW=0; LCD.A0=cd;	//       
	LCD.CS=lr; LCD.D=b;	//         
	Delay(>40ns);		//    (tAW)
	LCD.E=0; Delay(>160ns);	//  E=0 (     (tDS))
	LCD.E=1;		//  E 
	Delay(>(2000ns-40ns-160ns));	//     E=0
}

byte ReadByte(bit cd, bit lr) {
byte b;
//       
	LCD.RW=1; LCD.A0=cd;	//      
	LCD.CS=lr;		//   
	Delay(>40ns);		//    (tAW)
	LCD.E=0; Delay(>300ns);	//    E=0 (  (tACC)  )
	b=LCD.D;		//     (     120)
	LCD.E=1;		//  E 
	Delay(>(2000ns-40ns-300ns));	//     E=0
	return b;		//  
}

// ,         .
//           .
//        .
const byte Logo122[4][122]=//122x32 pixel,  8     
{
	{	0xFF,0x01,0x01,0x01,0x01,0xC1,0xE1,0xB1,0x11,0x1D,0x1D,0x7F,0x7F,0xFF,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFD,0xFD,0xF9,0xB1,
		0xF1,0xE1,0x81,0x01,0x01,0x01,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,
		0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,
		0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,
		0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,
		0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,
		0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xC1,0xFF
	},
	{	0xFF,0xE0,0x7C,0x7F,0x7F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF8,0x6F,0x6F,0x07,
		0x07,0x06,0x00,0x00,0x03,0x03,0x0F,0x3F,0x07,0x07,0x07,0x03,0x03,0x07,0x0F,0x3B,
		0x13,0x80,0x80,0x23,0x9E,0xF8,0xF8,0xF8,0xFC,0xFE,0xFE,0xFE,0xFC,0x00,0x00,0x00,
		0x80,0x80,0xE0,0xF8,0xFC,0xFE,0xFE,0xFE,0xFC,0x00,0x00,0x00,0x60,0xF0,0xF8,0xF8,
		0x7C,0x3E,0x1E,0x1E,0x1E,0x1E,0x1E,0x1E,0x1E,0x3E,0x3E,0x7E,0xFC,0xF8,0xF0,0xE0,
		0xC0,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xE0,0xF8,0xFC,0xFE,
		0xFE,0xFE,0xFE,0xFC,0x00,0x1C,0x3E,0x3E,0x3E,0x3E,0x3E,0x3E,0x3E,0xFE,0xFE,0xFE,
		0xFE,0xFE,0x3E,0x3E,0x3E,0x3E,0x3E,0x3E,0x1C,0xFF
	},
	{	0xFF,0x07,0x7C,0xE0,0x80,0x00,0x1F,0x3F,0xFF,0xFF,0xFF,0xFF,0x0F,0x30,0x38,0x00,
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,
		0xE0,0xF0,0xFC,0xFF,0xFF,0x3F,0x0F,0x03,0xFF,0xFF,0xFF,0xFF,0xFF,0xF8,0xFE,0xFF,
		0x7F,0x7F,0x1F,0x0F,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x00,0x18,0x3C,0x7E,0x7E,0x7E,0x7E,0x7E,0x7E,0x3C,0x3C,0x18,0x00,0x00,0x01,0xFF,
		0xFF,0xFF,0xFF,0x00,0x00,0x80,0xE0,0xF0,0xFC,0xFE,0xFF,0x7F,0x1F,0x07,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,
		0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF
	},
		0xFF,0x80,0x80,0x80,0x80,0x83,0x86,0x8C,0x98,0xB0,0xB0,0xE0,0xC0,0xC0,0x80,0x80,
		0x80,0x80,0x80,0x80,0x80,0x80,0xC0,0xC0,0xC0,0xC0,0xC0,0xE0,0xF8,0xFC,0xFF,0xFF,
		0xBF,0x8F,0x87,0x81,0x80,0x80,0x80,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0x9F,0x83,0x80,
		0x80,0x80,0x80,0x80,0xFF,0xFF,0xFF,0xFF,0xFF,0x80,0x80,0x80,0x86,0x8F,0x9F,0xBF,
		0xFE,0xFC,0xF8,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF8,0xF8,0xFC,0xFE,0xBF,0x9F,0x8F,
		0x87,0xE3,0xF9,0xFC,0xFF,0xFF,0xBF,0x9F,0x87,0x81,0x80,0x80,0x80,0x80,0xFF,0xFF,
		0xFF,0xFF,0xFF,0xFF,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xFF,0xFF,0xFF,
		0xFF,0xFF,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0xFF
	}
};
